// initialize.ck

// SOMETHING HERE NEXT WEEK!
// Add all classes here!
me.dir() + "/beat.ck" => string BPMPath;
Machine.add(BPMPath) => int bpm;

// add score.ck
me.dir() + "/melody.ck" => string scorePath;
Machine.add(scorePath) => int score;


Hid hi;
HidMsg msg;

// which keyboard
0 => int device;
// get from command line
if( me.args() ) me.arg(0) => Std.atoi => device;

// open keyboard (get device number from command line)
if( !hi.openKeyboard( device ) ) me.exit();
<<< "keyboard '" + hi.name() + "' ready", "" >>>;

// infinite event loop
while( true )
{
    // wait on event
    hi => now;
    
    // get one or more messages
    while( hi.recv( msg ) )
    {
        // check for action type
        if( msg.isButtonDown() && msg.which == 20)
        {
            <<< "down:", msg.which, "(code)", msg.key, "(usb key)", msg.ascii, "(ascii)" >>>;
            Machine.remove(bpm);
            Machine.remove(score);
        } 
        else
        {
            <<< "up:", msg.which, "(code)", msg.key, "(usb key)", msg.ascii, "(ascii)" >>>;
        }
    }
}