// piano.ck

0.7 => float volumn;
0.3 => float beatVolumn;

fun void foo()
{

// sound chain
Rhodey piano[4];
piano[1] => dac; 
piano[2] => dac;




// chord 2D array
[[36,24],[34,22],[32,20],[31,19],[35,23]] @=> int chordz[][];

Hid hi;
HidMsg msg;


// which keyboard
0 => int device;
// get from command line
if( me.args() ) me.arg(0) => Std.atoi => device;

// loop 
while( true )  
{
    // build first chord
    for( 0 => int i; i < 2; i++ )  
    {
        Std.mtof(chordz[0][i]) => piano[i].freq;
        volumn => piano[i].noteOn;
    }
    0.3 :: second => now;
    
    for( 0 => int i; i < 2; i++ )  
    {
        Std.mtof(chordz[0][i]) => piano[i].freq;
        volumn => piano[i].noteOn;
    }
    0.3 :: second => now;
    
    0.6 :: second => now;
    // build second chord
    for( 0 => int i; i < 2; i++ )  
    {
        Math.mtof(chordz[1][i]) => piano[i].freq;
        volumn => piano[i].noteOn;
    }
    0.3 :: second => now;
    
    for( 0 => int i; i < 2; i++ )  
    {
        Math.mtof(chordz[1][i]) => piano[i].freq;
        volumn => piano[i].noteOn;
    }
    0.3 :: second => now;
    
    0.6 :: second => now;

    // build third chord
    for( 0 => int i; i < 2; i++ )  
    {
        Math.mtof(chordz[2][i]) => piano[i].freq;
        volumn => piano[i].noteOn;
    }
    0.3 :: second => now;
    
    for( 0 => int i; i < 2; i++ )  
    {
        Math.mtof(chordz[2][i]) => piano[i].freq;
        volumn => piano[i].noteOn;
    }
    0.3 :: second => now;
    
    0.6 :: second => now;

    // build fourth chord
    for( 0 => int i; i < 2; i++ )  
    {
        Math.mtof(chordz[3][i]) => piano[i].freq;
        volumn => piano[i].noteOn;
    }
    0.3 :: second => now;
    
    for( 0 => int i; i < 2; i++ )  
    {
        Math.mtof(chordz[3][i]) => piano[i].freq;
        volumn => piano[i].noteOn;
    }
    0.3 :: second => now;
    
    0.3 :: second => now;
    
    // build fifth chord
    for( 0 => int i; i < 2; i++ )  
    {
        Math.mtof(chordz[4][i]) => piano[i].freq;
        volumn => piano[i].noteOn;
    }
    0.3 :: second => now;
    
    



}
}


fun void foo1()
{
    // kick.ck
    
    // sound chain
    SndBuf hihat => dac;
    SndBuf kick => dac;
    SndBuf snare => dac;
    
    // me.dirUp 
    //me.dir() + "/audio/hihat_01.wav" => hihat.read;
    me.dir() + "/hihat1.wav" => hihat.read;
    me.dir() + "/kick1.wav" => kick.read;
    me.dir() + "/snare1.wav" => snare.read;
    
    
    // parameter setup
    beatVolumn => hihat.gain;
    beatVolumn => kick.gain;
    beatVolumn => snare.gain;
    
    
    
    // loop 
    while( true )  
    {
        //Math.random2f(0.1,.3) => hihat.gain;
        //Math.random2f(.9,1.2) => hihat.rate;
        0 => kick.pos;
        0 => hihat.gain;
        0 => snare.gain;
        beatVolumn => kick.gain;
        0.3 :: second => now;
        0 => hihat.pos;
        beatVolumn => hihat.gain;
        0.3 :: second => now;
        0 => snare.pos;
        beatVolumn => snare.gain;
        0.3 :: second => now;
        0 => hihat.pos;
        0.3 :: second => now;
        
    }
 
}

spork ~ foo() @=> Shred @ s;
spork ~ foo1() @=> Shred @ s1;

fun void foo2()
{
    Hid hi;
    HidMsg msg;
    
    // which keyboard
    0 => int device;
    // get from command line
    if( me.args() ) me.arg(0) => Std.atoi => device;
    
    // open keyboard (get device number from command line)
    if( !hi.openKeyboard( device ) ) me.exit();
    <<< "keyboard '" + hi.name() + "' ready", "" >>>;
    
    // infinite event loop
    while( true )
    {
        // wait on event
        hi => now;
        
        // get one or more messages
        while( hi.recv( msg ) )
        {
            // check for action type
            if( msg.isButtonDown() && msg.which == 46)
            {
                if (volumn < 1.0)
                {
                    volumn + 0.1 => volumn;
                    beatVolumn + 0.1 => beatVolumn;
                }
                
                <<< "down:", msg.which, "(code)", msg.key, "(usb key)", msg.ascii, "(ascii)" >>>;
            } 
            else if( msg.isButtonDown() && msg.which == 45)
            {
                if (volumn >= 0.2)
                {
                    volumn - 0.1 => volumn;
                    beatVolumn - 0.1 => beatVolumn;
                }
                <<< "down:", msg.which, "(code)", msg.key, "(usb key)", msg.ascii, "(ascii)" >>>;
            }
            else if( msg.isButtonDown() && msg.which == 20)
            {
                Machine.remove( s.id() );
                Machine.remove( s1.id() );
            } 
                            
            else
            {
                <<< "up:", msg.which, "(code)", msg.key, "(usb key)", msg.ascii, "(ascii)" >>>;
            }
        }
    } 
    
}

spork ~ foo2();
while( true )
    1::second => now;
